ForwardingQueue
Date: 2016-05-24

com.google.common.collect

## Class ForwardingQueue<E>

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.collect.ForwardingCollection<E>
    - - com.google.common.collect.ForwardingQueue<E>

- All Implemented Interfaces:
    java.lang.Iterable<E>, java.util.Collection<E>, java.util.Queue<E>
  Direct Known Subclasses:
    EvictingQueue, ForwardingBlockingQueue, ForwardingDeque

      @GwtCompatible
      public abstract class ForwardingQueue<E>
      extends ForwardingCollection<E>
      implements java.util.Queue<E>

  A queue which forwards all its method calls to another queue. Subclasses should override one or more methods to modify the behavior of the backing queue as desired per the decorator pattern.

  Warning: The methods of `ForwardingQueue` forward indiscriminately to the methods of the delegate. For example, overriding `ForwardingCollection.add(E)` alone will not change the behavior of `offer(E)` which can lead to unexpected behavior. In this case, you should override `offer` as well, either providing your own implementation, or delegating to the provided `standardOffer` method.

  The `standard` methods are not guaranteed to be thread-safe, even when all of the methods that they depend on are thread-safe.

  Since:
    2.0

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ForwardingQueue()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract java.util.Queue<E>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
    `E` | `element()`
    `boolean` | `offer(E o)`
    `E` | `peek()`
    `E` | `poll()`
    `E` | `remove()`
    `protected boolean` | `standardOffer(E e)` A sensible definition of `offer(E)` in terms of `ForwardingCollection.add(E)`.
    `protected E` | `standardPeek()` A sensible definition of `peek()` in terms of `element()`.
    `protected E` | `standardPoll()` A sensible definition of `poll()` in terms of `remove()`.

    - ### Methods inherited from class com.google.common.collect.ForwardingCollection

      `add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, standardAddAll, standardClear, standardContains, standardContainsAll, standardIsEmpty, standardRemove, standardRemoveAll, standardRetainAll, standardToArray, standardToArray, standardToString, toArray, toArray`

    - ### Methods inherited from class com.google.common.collect.ForwardingObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Queue

      `add`

    - ### Methods inherited from interface java.util.Collection

      `addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

- - ### Constructor Detail

    - #### ForwardingQueue

          protected ForwardingQueue()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### delegate

          protected abstract java.util.Queue<E> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingCollection<E>`

    - #### offer

          public boolean offer(E o)

      Specified by:
        `offer` in interface `java.util.Queue<E>`

    - #### poll

          public E poll()

      Specified by:
        `poll` in interface `java.util.Queue<E>`

    - #### remove

          public E remove()

      Specified by:
        `remove` in interface `java.util.Queue<E>`

    - #### peek

          public E peek()

      Specified by:
        `peek` in interface `java.util.Queue<E>`

    - #### element

          public E element()

      Specified by:
        `element` in interface `java.util.Queue<E>`

    - #### standardOffer

          protected boolean standardOffer(E e)

      A sensible definition of `offer(E)` in terms of `ForwardingCollection.add(E)`. If you override `ForwardingCollection.add(E)`, you may wish to override `offer(E)` to forward to this implementation.
      Since:
        7.0

    - #### standardPeek

          protected E standardPeek()

      A sensible definition of `peek()` in terms of `element()`. If you override `element()`, you may wish to override `peek()` to forward to this implementation.
      Since:
        7.0

    - #### standardPoll

          protected E standardPoll()

      A sensible definition of `poll()` in terms of `remove()`. If you override `remove()`, you may wish to override `poll()` to forward to this implementation.
      Since:
        7.0